#!/bin/sh
# changedetection v1.1@geimist
# /volume1/homes/admin/script/changedetection/changedetection.sh

# Definition der Variablen:
    EMPFAENGER=empfaenger@domain.de
    ABSENDER='Diskstation <admin@domain.de>'

#--------------------------------------------- AB HIER NICHTS MEHR ÄNDERN ---------------------------------------------
APPDIR=$(cd $(dirname $0);pwd)
ERROR=0
ABSENDER="From: ${ABSENDER}"

if [ ! -d "${APPDIR}/tmp/" ] ; then
    mkdir "${APPDIR}/tmp"
fi
if [ ! -d "${APPDIR}/change_detected/" ] ; then
    mkdir "${APPDIR}/change_detected"
fi

while read i # Quelle zeilenweise einlesen
    do 
        
        if [ "$i" == "" ]; then
            continue
        elif echo "$i" | grep -q '^#'; then
            continue
        fi

        NAME=`echo $i | awk -F ' "' '{print $1}' | sed 's/\"//g ; s/\ $//g'`
        LINK=`echo $i | awk -F ' "' '{print $2}' | sed 's/\"//g'`
        echo -e; echo "=> ${NAME}:"

        if [ -f "${APPDIR}/tmp/${NAME}.txt" ] ; then
            mv "${APPDIR}/tmp/${NAME}.txt" "${APPDIR}/tmp/${NAME}_old.txt"
        fi
        
        # 1.: lade aktuelle index.html
        #---------------------------------------------
        machinetyp=`uname --machine`
	    if [ $machinetyp = "x86_64" ]; then  
            ${APPDIR}/links_APP/bin/links -dump "$LINK" -memory-cache-size 1 -ssl.certificates 0 -codepage "utf-8" -http.fake-firefox 1 -anonymous > "${APPDIR}/tmp/${NAME}.txt"
        else
            links -dump "$LINK" -memory-cache-size 1 -ssl.certificates 0 -codepage "utf-8" -http.fake-firefox 1 -anonymous > "${APPDIR}/tmp/${NAME}.txt"
        fi
            # links = SPK von synocommunity https://synocommunity.com/package/links
            # manual: https://www.mankier.com/1/links2
            # Parameter "ssl.certificates 0" in Datei ~/.links/links.cfg notwendig oder direkt übergeben (warum können Certs nicht validiert werden?)
        
        filesize=$(ls -l "${APPDIR}/tmp/${NAME}.txt" | awk '{ print $5 }')
        
        if [ "$filesize" -eq 0 ]; then
            echo "Download fehlgeschlagen - ${NAME} wird übersprungen"
            mv "${APPDIR}/tmp/${NAME}_old.txt" "${APPDIR}/tmp/${NAME}.txt" # alte Datei wiederherstellen
            continue
        fi
        
        # 2.: vergleiche Hashes, ggf. Änderung mailen
        #---------------------------------------------
        difflog=`diff -q "${APPDIR}/tmp/${NAME}.txt" "${APPDIR}/tmp/${NAME}_old.txt"`
        
        if [ $? -eq 0 ]; then
            echo "keine Änderung für ${NAME} gefunden"
            rm "${APPDIR}/tmp/${NAME}_old.txt"
        elif [ $? -eq 1 ]; then
            echo "Änderung für ${NAME} gefunden"
        	if [ -f "${APPDIR}/tmp/${NAME}_old.txt" ] ; then
                # VARDIFF=`diff -y --suppress-common-lines "${APPDIR}/tmp/${NAME}_old.txt" "${APPDIR}/tmp/${NAME}.txt"`
                VARDIFF=`diff -y "${APPDIR}/tmp/${NAME}_old.txt" "${APPDIR}/tmp/${NAME}.txt" | head -c 100k`

                echo "es wurden Änderungen auf der Website $LINK gefunden!" > "/tmp/ChangeDetectionMail.txt"
                echo -e >> "/tmp/ChangeDetectionMail.txt"
                echo "Änderungen:" >> "/tmp/ChangeDetectionMail.txt"
                echo "${VARDIFF}" >> "/tmp/ChangeDetectionMail.txt"

            # Mailen (php):
            	echo $message
            	subject="! ! ! ACHTUNG ! ! ! - Änderung für ${NAME} gefunden"
                /usr/bin/php -r "mail('$EMPFAENGER', '$subject', '`cat /tmp/ChangeDetectionMail.txt`', '$ABSENDER');"
                
            	synodsmnotify @administrators "! ! Änderung ${NAME} ! !" "$message"
            	
                mv "${APPDIR}/tmp/${NAME}_old.txt" "${APPDIR}/change_detected/${NAME}_`date +%Y`-`date +%m`-`date +%d`_`date +%H`-`date +%M`_before.txt"
                cp "${APPDIR}/tmp/${NAME}.txt" "${APPDIR}/change_detected/${NAME}_`date +%Y`-`date +%m`-`date +%d`_`date +%H`-`date +%M`_current.txt"
            fi
        fi
    done < "${APPDIR}/SITES.txt"
    
    if [ "$ERROR" -eq 1 ]; then
        exit 1
    fi
    
exit

# Changelog:
#   1.1
#       - Anpassungen an diff / Verzicht auf cksum
#       - Größenbeschränkung der gelogten Änderung auf 100KB
#       - 

    